﻿using System;
using System.Threading;
using System.Windows.Input;

using DevExpress.Xpf.Mvvm;

namespace TestProject
{
    /// <summary>
    /// 메인 뷰 모델
    /// </summary>
    public class MainViewModel : ViewModelBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Show Splash Screen 명령 - ShowSplashScreenCommand

        /// <summary>
        /// Show Splash Screen 명령
        /// </summary>
        public ICommand ShowSplashScreenCommand { get; private set; }

        #endregion
        #region 스플래시 화면 서비스 - SplashScreenService

        /// <summary>
        /// 스플래시 화면 서비스
        /// </summary>
        ISplashScreenService SplashScreenService
        {
            get
            {
                return GetService<ISplashScreenService>();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainViewModel()
        {
            ShowSplashScreenCommand = new DelegateCommand(OnShowSplashScreenCommandExecute);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Show Splash Screen 명령 실행시 처리하기 - OnShowSplashScreenCommandExecute()

        /// <summary>
        /// Show Splash Screen 명령 실행시 처리하기
        /// </summary>
        private void OnShowSplashScreenCommandExecute()
        {
            if(!SplashScreenService.IsSplashScreenActive)
            {
                SplashScreenService.ShowSplashScreen();

                Thread.Sleep(TimeSpan.FromSeconds(3));

                SplashScreenService.HideSplashScreen();
            }
        }

        #endregion
    }
}