﻿using System;
using System.Windows;

using DevExpress.Xpf.Core;

namespace TestProject
{
    /// <summary>
    /// 스플래시
    /// </summary>
    public partial class SplashScreenWindow : Window, ISplashScreen
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SplashScreenWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public SplashScreenWindow()
        {
            InitializeComponent();

            this.storyboard.Completed += storyboard_Completed;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region (ISplashScreen) 진행하기 - Progress(value)

        /// <summary>
        /// 진행하기
        /// </summary>
        /// <param name="value">값</param>
        public void Progress(double value)
        {
            this.progressBar.Value = value;
        }

        #endregion
        #region (ISplashScreen) 스플래시 화면 닫기 - CloseSplashScreen()

        /// <summary>
        /// 스플래시 화면 닫기
        /// </summary>
        public void CloseSplashScreen()
        {
            this.storyboard.Begin(this);
        }

        #endregion
        #region (ISplashScreen) 진행 상태 설정하기 - SetProgressState(isIndeterminate)

        /// <summary>
        /// 진행 상태 설정하기
        /// </summary>
        /// <param name="isIndeterminate">미결정 여부</param>
        public void SetProgressState(bool isIndeterminate)
        {
            this.progressBar.IsIndeterminate = isIndeterminate;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 스토리 보드 완료시 처리하기 - storyboard_Completed(sender, e)

        /// <summary>
        /// 스토리 보드 완료시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void storyboard_Completed(object sender, EventArgs e)
        {
            this.storyboard.Completed -= storyboard_Completed;

            Close();
        }

        #endregion
    }
}